# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Variable-Magic
Version:	0.53
Release:	1.%{__distinit}%{__distvers}
Summary:	Associate user-defined magic to variables from Perl
License:	GPL+ or Artistic
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Variable-Magic/
Source0:	http://search.cpan.org/CPAN/authors/id/V/VP/VPIT/Variable-Magic-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildRequires:	perl(base)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(lib)
BuildRequires:	perl(Module::ExtractUse) >= 0.24
BuildRequires:	perl(Parse::RecDescent) >= 1.967006
BuildRequires:	perl(Test::More)
BuildRequires:	perl(threads)
BuildRequires:	perl(threads::shared)
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%{?perl_default_filter}

%description
Magic is Perl way of enhancing objects. This mechanism let the user add
extra data to any variable and hook syntactical operations (such as access,
assignation or destruction) that can be applied to it. With this module,
you can add your own magic to any variable without the pain of the C API.

%prep
%setup -q -n Variable-Magic-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor OPTIMIZE="%{optflags}"
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} \;
find %{buildroot} -type f -name '*.bs' -size 0 -exec rm -f {} \;
%{_fixperms} %{buildroot}

%check
make test

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc Changes README
%{perl_vendorarch}/auto/Variable/
%{perl_vendorarch}/Variable/
%{_mandir}/man3/Variable::Magic.3pm*

%changelog
* Sun Sep  1 2013 Paul Howarth <paul@city-fan.org> - 0.53-1
- Update to 0.53
  - This is a maintenance release; the code contains no functional change
  - Fix typo (CPAN RT#86338)
  - Author tests are no longer bundled with this distribution
- Drop buildreqs only needed for author tests

* Tue Jul 23 2013 Paul Howarth <paul@city-fan.org> - 0.52-3
- Perl 5.18 rebuild

* Fri Jul  5 2013 Paul Howarth <paul@city-fan.org> - 0.52-2
- Don't BR: perl(Test::Kwalitee) when bootstrapping

* Mon Nov  5 2012 Paul Howarth <paul@city-fan.org> - 0.52-1
- Update to 0.52
  - The new constant VMG_COMPAT_SCALAR_NOLEN evaluates to true when your perl
    does not call 'len' magic for scalars, which is the case for perl 5.17.4
    and above (CPAN RT#80388)
  - t/35-stash.t has been taught about perl 5.17.4
  - Author tests overhaul
- Bump module version requirements for author tests

* Tue Aug 21 2012 Paul Howarth <paul@city-fan.org> - 0.51-1
- Update to 0.51
  - It is now safe to call dispell() from inside 'free', 'copy' and 'uvar'
    callbacks to dispell the magic currently in use
  - Exceptions thrown from inside a 'free' callback are now always consistently
    propagated outside of the callback; they used to be lost when the 'free'
    callback was invoked at the end of an eval block or string
  - The 'reset RMG flag' workaround used to allow wizards with both 'uvar' and
    'clear' magics to be cast onto a hash, has been made thread-safe

* Thu Jul 12 2012 Paul Howarth <paul@city-fan.org> - 0.50-2
- Perl 5.16 rebuild

* Mon Jun 25 2012 Paul Howarth <paul@city-fan.org> - 0.50-1
- Update to 0.50
  - Less memory is leaked when a wizard is freed during global destruction, or
    when an exception is thrown from a 'free' callback
  - Fixed CPAN RT#77991: t/17-ctl.t fails with ActivePerl 5.14 and 5.16
  - t/35-stash.t has been taught about perl 5.17.1
  - Many documentation clarifications
- BR: perl(threads) and perl(threads::shared)

* Wed Jun 6  2012 Paul Howarth <paul@city-fan.org> - 0.49-1
- Update to 0.49
  - This is a maintenance release - the code contains no functional change;
    satisfied users of version 0.48 can skip this update
  - Fix CPAN RT#77644: t/17_ctl.t fails in test 44 since 5.17.0
  - t/99-kwalitee.t will be skipped when only problematic versions of its
    dependencies are available
- Don't need to remove empty directories from the buildroot
- Drop BR: perl(strict) and perl(warnings) as they're not dual-lived
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorarch}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Sat Feb 18 2012 Paul Howarth <paul@city-fan.org> - 0.48-1
- Update to 0.48
  - You can now pass a reference to undef as the magic callback in order to
    install a no-op callback
- BR: perl(base), perl(strict) and perl(warnings)

* Thu Oct 27 2011 Paul Howarth <paul@city-fan.org> - 0.47-1
- Update to 0.47
  - The new constant VMG_COMPAT_HASH_DELETE_NOUVAR_VOID evaluates to true when
    "delete $hash{key}" does not call 'delete' uvar magic in void context
  - The MAGIC tokens created by this module no longer use the mg_private member
    for storing a "magical" signature
  - Triggering magic in a thread on a variable cloned from the main interpreter,
    and when the wizard already went out of scope, will no longer segfault
  - The pointer table is no longer needed to ensure thread safety; the size of
    the object code is about 8% smaller for threaded perls
  - Threads tests will not fail any more if resource constraints prevent the
    system from creating all the required threads

* Tue Jun 21 2011 Paul Howarth <paul@city-fan.org> - 0.46-4
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Fri Apr 29 2011 Paul Howarth <paul@city-fan.org> - 0.46-3
- Import from Fedora

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.46-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Mon Jan 24 2011 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.46-1
- Update to 0.46

* Mon Nov 22 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.45-1
- Update to 0.45

* Wed Sep 29 2010 jkeating - 0.44-2
- Rebuilt for gcc bug 634757

* Sat Sep 25 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.44-1
- Update to 0.44

* Sat Jun 26 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.43-1
- Update to 0.43

* Wed May 19 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.42-1
- Update to 0.42

* Fri May 07 2010 Marcela Maslanova <mmaslano@redhat.com> - 0.41-2
- Mass rebuild with perl-5.12.0

* Sun Apr 11 2010 Emmanuel Seyman <emmanuel.seyman@club-internet.fr> - 0.41-1
- Update to 0.41

* Mon Dec  7 2009 Stepan Kasal <skasal@redhat.com> - 0.37-2
- Rebuild against perl 5.10.1

* Sun Sep 27 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.37-1
- Auto-update to 0.37 (by cpan-spec-update 0.01)

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.34-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Sat May 16 2009 Chris Weyl <cweyl@alumni.drew.edu> - 0.34-1
- Update to 0.34 (for B::Hooks::EndOfScope 0.08)
- Filter private Perl .so's

* Mon Mar  9 2009 Allisson Azevedo <allisson@gmail.com> - 0.32-1
- Update to 0.32

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.30-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sat Feb 14 2009 Allisson Azevedo <allisson@gmail.com> - 0.30-1
- Initial rpm release
